---
title: WebGLRenderingContext.getFramebufferAttachmentParameter()
slug: Web/API/WebGLRenderingContext/getFramebufferAttachmentParameter
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.getFramebufferAttachmentParameter()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> returns information about a framebuffer's attachment.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">any <var>gl</var>.getFramebufferAttachmentParameter(<var>target</var>, <var>attachment</var>, <var>pname</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target). Possible values:
 <ul>
  <li><code>gl.FRAMEBUFFER</code>: Collection buffer data storage of color, alpha, depth and stencil buffers used to render an image.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.DRAW_FRAMEBUFFER</code>: Equivalent to <code>gl.FRAMEBUFFER</code>. Used as a destination for drawing, rendering, clearing, and writing operations.</li>
    <li><code>gl.READ_FRAMEBUFFER</code>: Used as a source for reading operations.</li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>attachment</dt>
 <dd>A {{domxref("GLenum")}} specifying the attachment point for the <code>texture</code>. Possible values:
 <ul>
  <li><code>gl.COLOR_ATTACHMENT0</code>: Texture attachment for the framebuffer's color buffer.</li>
  <li><code>gl.DEPTH_ATTACHMENT</code>: Texture attachment for the framebuffer's depth buffer.</li>
  <li><code>gl.STENCIL_ATTACHMENT</code>: Texture attachment for the framebuffer's stencil buffer.</li>
  <li><code>gl.DEPTH_STENCIL_ATTACHMENT</code>: Texture attachment for both, the depth and stencil buffer.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.COLOR_ATTACHMENT1<br>
     gl.COLOR_ATTACHMENT2<br>
     gl.COLOR_ATTACHMENT3<br>
     gl.COLOR_ATTACHMENT4<br>
     gl.COLOR_ATTACHMENT5<br>
     gl.COLOR_ATTACHMENT6<br>
     gl.COLOR_ATTACHMENT7<br>
     gl.COLOR_ATTACHMENT8<br>
     gl.COLOR_ATTACHMENT9<br>
     gl.COLOR_ATTACHMENT10<br>
     gl.COLOR_ATTACHMENT11<br>
     gl.COLOR_ATTACHMENT12<br>
     gl.COLOR_ATTACHMENT13<br>
     gl.COLOR_ATTACHMENT14<br>
     gl.COLOR_ATTACHMENT15</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_draw_buffers")}} extension:
   <ul>
    <li><code>ext.COLOR_ATTACHMENT0_WEBGL</code> (same as <code>gl.COLOR_ATTACHMENT0</code>)<br>
     <code>ext.COLOR_ATTACHMENT1_WEBGL<br>
     ext.COLOR_ATTACHMENT2_WEBGL<br>
     ext.COLOR_ATTACHMENT3_WEBGL<br>
     ext.COLOR_ATTACHMENT4_WEBGL<br>
     ext.COLOR_ATTACHMENT5_WEBGL<br>
     ext.COLOR_ATTACHMENT6_WEBGL<br>
     ext.COLOR_ATTACHMENT7_WEBGL<br>
     ext.COLOR_ATTACHMENT8_WEBGL<br>
     ext.COLOR_ATTACHMENT9_WEBGL<br>
     ext.COLOR_ATTACHMENT10_WEBGL<br>
     ext.COLOR_ATTACHMENT11_WEBGL<br>
     ext.COLOR_ATTACHMENT12_WEBGL<br>
     ext.COLOR_ATTACHMENT13_WEBGL<br>
     ext.COLOR_ATTACHMENT14_WEBGL<br>
     ext.COLOR_ATTACHMENT15_WEBGL</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>pname</dt>
 <dd>A {{domxref("GLenum")}} specifying information to query. Possible values:
 <ul>
  <li><code>gl.FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE</code>: The type which contains the attached image.</li>
  <li><code>gl.FRAMEBUFFER_ATTACHMENT_OBJECT_NAME</code>: The texture or renderbuffer of the attached image ({{domxref("WebGLRenderbuffer")}} or {{domxref("WebGLTexture")}}).</li>
  <li><code>gl.FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL</code>: Mipmap level. Default value: 0.</li>
  <li><code>gl.FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE</code>: The name of cube-map face of the texture.</li>
  <li>When using the {{domxref("EXT_sRGB")}} extension:
   <ul>
    <li><code>ext.FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT</code>: The framebuffer color encoding.</li>
   </ul>
  </li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_BLUE_SIZE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_GREEN_SIZE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_RED_SIZE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE</code></li>
    <li><code>gl.FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("OVR_multiview2")}} extension:
   <ul>
    <li><code>ext.FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR</code>: the number of views of the framebuffer object attachment.</li>
    <li><code>ext.FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR</code>:  the base view index of the framebuffer object attachment.</li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Depends on the requested information (as specified with <code>pname</code>). Either a {{domxref("GLint")}}, a {{domxref("GLenum")}}, a {{domxref("WebGLRenderbuffer")}}, or a {{domxref("WebGLTexture")}}.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col"><code>pname</code> parameter</th>
   <th scope="col">Return value</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE</code></td>
   <td>A {{domxref("GLenum")}} indicating the type of the texture. Either <code>gl.RENDERBUFFER</code>, <code>gl.TEXTURE</code>, or if no image is attached, <code>gl.NONE</code>.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_OBJECT_NAME</code></td>
   <td>The texture ({{domxref("WebGLTexture")}}) or renderbuffer ({{domxref("WebGLRenderbuffer")}}) of the attached image.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL</code></td>
   <td>A {{domxref("GLint")}} indicating the mipmap level. Default value: 0.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE</code></td>
   <td>A {{domxref("GLenum")}} indicating the name of cube-map face of the texture. Possible values:
    <ul>
     <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_X</code>: Image for the positive X face of the cube.</li>
     <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_X</code>: Image for the negative X face of the cube.</li>
     <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Y</code>: Image for the positive Y face of the cube.</li>
     <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Y</code>: Image for the negative Y face of the cube.</li>
     <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Z</code>: Image for the positive Z face of the cube.</li>
     <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Z</code>: Image for the negative Z face of the cube.</li>
    </ul>
   </td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE</code></td>
   <td>A {{domxref("GLint")}} indicating the number of bits in the alpha component of the attachment.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_BLUE_SIZE</code></td>
   <td>A {{domxref("GLint")}} indicating the number of bits in the blue component of the attachment.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING</code></td>
   <td>A {{domxref("GLenum")}} indicating the encoding of components of the specified attachment. Either <code>gl.LINEAR</code> or <code>gl.SRGB</code>.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE</code></td>
   <td>A {{domxref("GLenum")}} indicating the format of the components of the specified attachment. Either <code>gl.FLOAT</code>, <code>gl.INT</code>, <code>gl.UNSIGNED_INT</code>, <code>gl.SIGNED_NORMALIZED</code>, or <code>gl.UNSIGNED_NORMALIZED</code>.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE</code></td>
   <td>A {{domxref("GLint")}} indicating the number of bits in the depth component of the attachment.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_GREEN_SIZE</code></td>
   <td>A {{domxref("GLint")}} indicating the number of bits in the green component of the attachment.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_RED_SIZE</code></td>
   <td>A {{domxref("GLint")}} indicating the number of bits in the red component of the attachment.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE</code></td>
   <td>A {{domxref("GLint")}} indicating the number of bits in the stencil component of the attachment.</td>
  </tr>
  <tr>
   <td><code>gl.FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER</code></td>
   <td>A {{domxref("GLint")}} indicating the number of the texture layer which contains the attached image.</td>
  </tr>
  <tr>
   <td><code>ext.FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT</code></td>
   <td>A {{domxref("GLenum")}} indicating the framebuffer color encoding. Either <code>gl.LINEAR</code> or <code>ext.SRGB_EXT</code>.</td>
  </tr>
  <tr>
   <td><code>ext.FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR</code></td>
   <td>A {{domxref("GLsizei")}} indicating the number of views of the framebuffer object attachment.</td>
  </tr>
  <tr>
   <td><code>ext.FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR</code></td>
   <td>A {{domxref("GLint")}} indicating the base view index of the framebuffer object attachment.</td>
  </tr>
 </tbody>
</table>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if <code>target</code> is not <code>gl.FRAMEBUFFER</code>, <code>gl.DRAW_FRAMEBUFFER</code>, <code>gl.READ_FRAMEBUFFER</code> or if <code>attachment</code> is not one of the accepted attachment points.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.getFramebufferAttachmentParameter(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0,
                                     gl.FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.6", "getFramebufferAttachmentParameter")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glGetFramebufferAttachmentParameteriv.xml", "glGetFramebufferAttachmentParameteriv")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.4", "getFramebufferAttachmentParameter")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL 2.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glGetFramebufferAttachmentParameteriv.xhtml", "glGetFramebufferAttachmentParameteriv")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.getFramebufferAttachmentParameter")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createFramebuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.deleteFramebuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.isFramebuffer()")}}</li>
 <li>Other buffers: {{domxref("WebGLBuffer")}}, {{domxref("WebGLRenderbuffer")}}</li>
 <li>{{domxref("EXT_sRGB")}}</li>
 <li>{{domxref("WEBGL_draw_buffers")}}</li>
</ul>
